#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <conio.h>
#include <graphics.h>
#include <string.h>
#include <ctype.h>
#include <dos.h>
#include <time.h>

/* prototypes */
void start_graphics();
extern void start_clock(...);
extern void stop_clock(...);

extern int ms_counter; /* millisecond timer from MSCLOCK */

/* program constants */
#define Field_Color 2 /* green */
#define Target_Color 4 /* red */
#define X_ORG 300
#define Y_ORG 250
#define R 40
#define REPEAT 10
#define POINTS 54
#define ITI 1000
#define SHUFFLE 5
/* Degree2 - rotated edge perception project - Scott Cost - 11/10/93 */
/* Must be compiled with MSCLOCK.CPP, RSC custom millisecond timer. */
int main (
	int argc,
	char* argv[] )
{
	FILE *outfile;
	int swap, dest, i, j, error, time;
	int line[POINTS*REPEAT];
	int err [POINTS];
	int x, y, x1, y1, x2, y2;
	char key;
	int response[POINTS*REPEAT];
	int n_hit[REPEAT*POINTS], n_time[REPEAT*POINTS];
	int go=0, nogo=0;

	start_clock();
	randomize();
	_setcursortype(_NOCURSOR);

	if ((outfile = fopen(argv[1], "w"))==NULL)
	{
		printf ("%s:  (Out)File Open Error.\n", argv[1]);
		getch();
		exit(1);
	}
	for (i=0; i<POINTS*REPEAT; i++) {
		line[i]=i%(POINTS); /* ten dpoints each, 5 d increment */
		if (line[i]>35) line[i]=36; /* 36 = blank */
	}
	for (j=0; j<SHUFFLE; j++) /* single shuffle SHUFFLE times */
		for (i=0; i<POINTS*REPEAT; i++) {
			dest = random(POINTS*REPEAT);
			swap = line[i];
			line[i] = line[dest];
			line[dest] = swap;
			n_hit[i]=n_time[i]=0;
		}
	clrscr;
	printf ("Edge Rotation/Perception Experiment 2.0\n\n");
	printf ("Lines set at various angles will be displayed, one at a time,\n");
	printf ("in the center of the screen.  Half will be vertical, half will\n");
	printf ("not.  Your task is to press the spacebar, as quickly as possible\n");
	printf ("when a rotated line appears (that is, ANY line which is not\n");
	printf ("vertical.  Do nothing if a vertical line appears.  The lines will\n");
	printf ("appear at 2 second intervals, and you will have 1 second to\n");
	printf ("respond.  Please do so AS QUICKLY AS POSSIBLE.  A beep will sound\n");
	printf ("if you are incorrect.\n\n");
	printf ("When you press return, there will be a 5 second pause, and then\n");
	printf ("the first line will be displayed.  Make yourself comfortable and\n");
	printf ("get ready.  This experiment will last approximately 24 minutes.\n");
	printf ("Hit any key when ready . . .");
	while (getch()==NULL);

	clrscr();
	ms_counter=0; /* pause . . . */
	while (ms_counter<5000);
	start_graphics();

	for (i=0; i<POINTS*REPEAT; i++) {

		/* enforce pseudo-randomization */
		if (line[i]==18) {nogo++; go=0;}
		else {go++; nogo=0;}
		while ((go>4) | (nogo>4)) { /* runs of 3 only */
			dest=random((POINTS*REPEAT)-i)+i;
			swap=line[i];
			line[i]=line[dest];
			line[dest]=swap;
			if (line[i]==18) {go=0; nogo++;}
			else {go++; nogo=0;}
		}

		ms_counter=0;
		circle(X_ORG,Y_ORG,5);
		/* set up line - x1 and y1 are quad 1 and 2 coordinates */
		x = R*(cos(5*line[i]*3.1416/180));
		y = (R*(sin(5*line[i]*3.1416/180)))*(.92); /* compress for symmetry */
		x1 = X_ORG + x; y1 = Y_ORG - y;
		x2 = X_ORG - x; y2 = Y_ORG + y;
		while (ms_counter<1000); /* fixation */
		ms_counter=0;
		/* 0-35 lines, 36 = blank */
		cleardevice();
		moveto(x1,y1);
		if (line[i]<36) lineto (x2,y2);
		error=1; time=1000;
		key = ' ';
		while (ms_counter<100);
		cleardevice();
		while (ms_counter<900) {
			if (kbhit()) {
				key = getch();
				if (line[i]!=36) error = 0;
				time = ms_counter;
			} /* if key== */
		} /* while loop */
		if ((time>999) & (line[i]==36)) error=0;

		if (key=='2') exit(1);
		/* ITI */
		cleardevice();
		ms_counter = 0;
		if (error==1) time = 1000;
		response[i] = time;
		if (time<1000) {
			n_time[line[i]] += time;
			n_hit[line[i]]++;
		}
		if (error==1) { /* swap out and repeat error */
			/* first, record */
			err[line[i]]++;
			sound(440);
			delay(400);
			nosound();
			dest=random((POINTS*REPEAT)-i)+i;
			swap=line[i];
			line[i]=line[dest];
			line[dest]=swap;
			i--;
		}
		while (kbhit()) key = getch(); /* clear keyboard */
		/* no ITI */ /* while (ms_counter<ITI); */
		/* results would be written here */
	} /* for loop */
	closegraph(); /* insulate text screen */
	stop_clock();
	for (i=0; i<36; i++)
		if ((n_hit[i]>0))
		fprintf (outfile, "%4d %6d\n", i*5, n_time[i]/n_hit[i]);
	fprintf (outfile, "\n");
	for (i=0; i<POINTS*REPEAT; i++)
			fprintf (outfile, "%4d %6d\n",line[i]*5,
			response[i]);
	fprintf (outfile,"Errors:\n");
	for (i=0; i<POINTS; i++)
			fprintf (outfile, "%4d %6d\n",line[i]*5, err [i]);
	fcloseall();
}

/* vga graphics initialization routine */
void start_graphics() {
	int gdriver=VGA, gmode=VGAHI, errorcode;
	/* int gdriver=IBM8514, gmode=IBM8514HI, errorcode; */
	initgraph(&gdriver, &gmode, "C:\\BORLANDC\\BGI\\"); /* enter graphics mode */
	errorcode=graphresult();
	if (errorcode!=grOk) {
		printf("Graphics error:  %s\n", grapherrormsg(errorcode));
		printf("Press any key to halt:");
		getch();
		exit(1);
	} /* from BC++ Lib Ref, pg. 299 */
	settextstyle(TRIPLEX_FONT, HORIZ_DIR, 1);
	/* setusercharsize(); for future use; font size must be set to zero */
}
