#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_LINE 300

/* neighbor - 1 match distance function - rsc 10/13/93     */
/* usage:  neighbor <word or word.list> [optional outfile] */
/* given a word or list of words, neighbor will find for   */
/* each the set of words (from the brown word frequency    */
/* corpus) that one match distance away; that is, they     */
/* differ by only one character.                           */
/* if file does not exist, interprets as single word       */
/* output goes to stdout, unless file name given           */
/* neighbor is case insensitive                            */

/* Will accept up to 12 character strings  */
main (
	int argc,
	char *argv[]
	)
{
  FILE *fp;
  int i, j, length;
  char line[MAX_LINE], command[MAX_LINE], *word;

  fp=fopen(argv[1], "r");
  if (argc==3) { strcpy (command, "rm "); /* remove old list */ 
    strcat (command, argv[2]); }
  if (fp==NULL) { /* compile command for single word */
  strcpy (command, "");

    if (strlen(argv[1])>12) {
      printf ("Can only accept strings of 12 characters or less.\n");
      exit(1);
    }

    /* set up main command line */
		strcpy (command, "grep -i '");
    for (i=0; i<strlen(argv[1]); i++) {
      strcat (command, " ");
      for (j=0; j<strlen(argv[1]); j++)
        if (i==j) strcat (command, "[a-z]");/* . */
        else {
          length=strlen(command);
          command[length]=argv[1][j];
          command[length+1]='\0'; /* recap string */
	}strcat (command, " ");
      if (i<(strlen(argv[1])-1)) strcat (command, "|"); /* concat */
    }
		strcat (command, "' lex");

		if (argc==3) { strcat (command, " > ");
			strcat (command, argv[2]);
		}
		system (command); /* if file no good, assume word */
	} else
	while ((fgets(line, MAX_LINE, fp))!=0) { /* word list */
		word=strtok(line, " \t\n");

		if (strlen(word)>12) {
			printf ("Can only accept strings of 12 characters or less.\n");
			exit(1);
		}

		/* set up main command line */
		strcpy (command, "grep -i '");
		for (i=0; i<strlen(word); i++) {
			strcat (command, " ");
			for (j=0; j<strlen(word); j++)
				if (i==j) strcat (command, "[a-z]");/* . */
				else {
					length=strlen(command);
					command[length]=word[j];
					command[length+1]='\0'; /* recap string */
	}strcat (command, " ");
			if (i<(strlen(word)-1)) strcat (command, "|"); /* concat */
		}
		strcat (command, "' lex");

		if (argc==3) { strcat (command, " > ");
			strcat (command , argv[2]); }
		system (command);
	}
	fclose(fp);
	return(0);
}



