/* 12/8/93 - scott cost - blend1 */
/* program to reformat and merge the francis and kutchera word freqency database with the */
/* nettalk corpus (w/ pronunciations) */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <curses.h>

#define MAX_LINE 255

/* prototypes */
char *convert(char[],char[]);

int main () { /* no arguments - special purpose program */
  FILE *f1, *f2, *f3;
  char line[MAX_LINE], line2[MAX_LINE];
  int fr1, fr2, fr3; /* frequency variables */
  char *word;
  char phon[50], phon2[50], stress[50], comp[50];
  int found;

  f1=fopen("word1","r");
  f3=fopen("word3","w");

  while (fgets(line,MAX_LINE,f1)!=NULL) {
    fr1=atoi(strtok(line," -")); /* clip at first hyphen */
    fr2=atoi(strtok(NULL," -")); 
    fr3=atoi(strtok(NULL," \t\n"));

    word=strtok(NULL," \t\n");
    strcpy(phon2,""); strcpy(stress,"");
    found=0;

    f2=fopen("word2","r");
    while (fgets(line2,MAX_LINE,f2)!=NULL) { /* now scan nettalk for ph. spelling */
      strcpy(comp,strtok(line2," \t\n"));
      if (strncasecmp(word,comp,1)==0) /* preprocessing */
      if (strncasecmp(word,comp,2)==0)
      if (strcasecmp(word,comp)==0) {
	found=1;
        strcpy(phon,strtok(NULL," \t\n"));
        strcpy(stress,strtok(NULL," \t\n"));
	convert(phon, phon2);
        /* printf("%20s %6d %5d %5d %20s %20s\n", word, fr1, fr2, fr3, phon2, stress); */
        /* fprintf(f3,"%s\t%d\t%d\t%d\t%s\t%s\n", word, fr1, fr2, fr3, phon2, stress); */
        break;
      }
    }
    /*if (found==0)*/ fprintf(f3,"%s\t%d\t%d\t%d\t%s\t%s\n", word, fr1, fr2, fr3, phon2, stress);
    fclose(f2);
  }
  fclose(f1);
  fclose(f3);
}

char *convert(s,r)
  char s[];
  char r[];
{
  int i, index;
  char x1[2], x2[2];

  strcpy(x1,"+");
  strcpy(x2,"+");
  strcpy(r,"");
  for (i=0; i<strlen(s); i++) {
    switch(s[i]) {
      case 'a': {strcat(r,"a"); break;}
      case 'b': {strcat(r,"b"); break;}
      case 'c': {x1[0]=141; strcat(r,x1);}
      case 'd': {strcat(r,"d"); break;}
      case 'e': {strcat(r,"e"); break;}
      case 'f': {strcat(r,"f"); break;}
      case 'g': {strcat(r,"g"); break;}
      case 'h': {strcat(r,"h"); break;}
      case 'i': {strcat(r,"i"); break;}
      case 'k': {strcat(r,"k"); break;}
      case 'l': {strcat(r,"l"); break;}
      case 'm': {strcat(r,"m"); break;}
      case 'n': {strcat(r,"n"); break;}
      case 'o': {strcat(r,"o"); break;}
      case 'p': {strcat(r,"p"); break;}
      case 'r': {strcat(r,"r"); break;}
      case 's': {strcat(r,"s"); break;}
      case 't': {strcat(r,"t"); break;}
      case 'u': {strcat(r,"u"); break;}
      case 'v': {strcat(r,"v"); break;}
      case 'w': {strcat(r,"w"); break;}
      case 'x': break;
      case 'y': {strcat(r,"j"); break;}
      case 'z': {strcat(r,"z"); break;}
      case 'A': {x1[0]= 73; strcat(r,x1); break;}
      case 'C': {x1[0]= 83; strcat(r,x1); break;}
      case 'D': {x1[0]= 68; strcat(r,x1); break;}
      case 'E': {x1[0]= 69; strcat(r,x1); break;}
      case 'G': {x1[0]= 78; strcat(r,x1); break;}
      case 'I': {x1[0]= 73; strcat(r,x1); break;}
      case 'J': {x1[0]= 90; strcat(r,x1); break;}
      case 'K': break;
      case 'L': {x1[0]= 56; strcat(r,"l"); strcat(r,x1); break;}
      case 'M': {x1[0]= 56; strcat(r,"m"); strcat(r,x1); break;}
      case 'N': {x1[0]= 56; strcat(r,"n"); strcat(r,x1); break;}
      case 'O': {x1[0]=141; x2[0]= 73; strcat(r,x1); strcat(r,x2); break;}
      case 'Q': break;
      case 'R': break;
      case 'S': {x1[0]= 83; strcat(r,x1); break;}
      case 'T': {x1[0]= 84; strcat(r,x1); break;}
      case 'U': break;
      case 'W': {x1[0]= 85; strcat(r,"a"); strcat(r,x1); break;}
      case 'X': {strcat(r,"ks"); break;}
      case 'Y': {x1[0]= 83; strcat(r,x1); break;}
      case 'Z': {x1[0]= 90; strcat(r,x1); break;}
      case '@': {x1[0]= 81; strcat(r,x1); break;}
      case '!': {strcat(r,"ts"); break;}
      case '#': {strcat(r,"gz"); break;}
      case '*': {strcat(r,"hw"); break;}
      case '^': {x1[0]=195; strcat(r,x1); break;}
      case '+': {strcat(r,"ua"); break;}
      default : break;
      }
  }
  return (r);
}



